HTTP::Request - Crystal 1.20.0

# class HTTP::Request

- HTTP::Request
- Reference
- Object

##
Overview

An HTTP request.

It serves both to perform requests by an `HTTP::Client` and to represent requests received by an `HTTP::Server`.

A request always holds an `IO` as a body. When creating a request with a `String` or `Bytes` its body will be a `IO::Memory` wrapping these, and the `Content-Length` header will be set appropriately.

NOTE To use `Request`, you must explicitly import it with `require "http/request"`

##
Defined in:

http/request.cr

##
Constructors

- .new(method : String, resource : String, headers : Headers | Nil = nil, body : String | Bytes | IO | Nil = nil, version : String = "HTTP/1.1") : self

##
Class Method Summary

- .from_io(io : IO, *, max_request_line_size : Int32 = HTTP::MAX_REQUEST_LINE_SIZE, max_headers_size : Int32 = HTTP::MAX_HEADERS_SIZE) : HTTP::Request | HTTP::Status | Nil

  Returns a `HTTP::Request` instance if successfully parsed, `nil` on EOF or `HTTP::Status` otherwise.

##
Instance Method Summary

- #body : IO | Nil
- #body=(body : String) : String
- #body=(body : Bytes) : String
- #body=(body : IO) : IO
- #body=(body : Nil) : Nil
- #content_length
- #content_length=(length : Int) : String
- #cookies : HTTP::Cookies

  Returns a convenience wrapper around querying and setting cookie related headers, see `HTTP::Cookies`.

- #form_params : HTTP::Params

  Returns a convenience wrapper to parse form params, see `URI::Params`.

- #form_params? : HTTP::Params | Nil

  Returns a convenience wrapper to parse form params, see `URI::Params`.

- #headers : Headers
- #headers=(headers : Headers)
- #host_with_port : String | Nil

  Returns request host with port from headers.

  DEPRECATED Use `headers["Host"]?` instead.

- #hostname : String | Nil

  Extracts the hostname from `Host` header.

- #if_match : Array(String) | Nil
- #if_none_match : Array(String) | Nil
- #ignore_body? : Bool
- #keep_alive? : Bool
- #local_address : Socket::Address | Nil

  The network address of the HTTP server.

- #local_address=(local_address : Socket::Address | Nil)

  The network address of the HTTP server.

- #method : String
- #method=(method : String)
- #path : String

  Returns the request's path component.

- #path=(path : String) : String

  Sets request's path component.

- #query : String | Nil

  Lazily parses and returns the request's query component.

- #query=(value : String | Nil) : String | Nil

  Sets request's query component.

- #query_params : URI::Params

  Returns a convenience wrapper around querying and setting query params, see `URI::Params`.

- #remote_address : Socket::Address | Nil

  The network address that sent the request to an HTTP server.

- #remote_address=(remote_address : Socket::Address | Nil)

  The network address that sent the request to an HTTP server.

- #resource : String
- #to_io(io : IO) : Nil
- #uri : URI

  Returns the underlying URI object.

- #version : String
- #version=(version : String)

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(method : String, resource : String, headers : Headers | Nil = nil, body : String | Bytes | IO | Nil = nil, version : String = "HTTP/1.1") : self #

##
Class Method Detail

def self.from_io(io : IO, *, max_request_line_size : Int32 = HTTP::MAX_REQUEST_LINE_SIZE, max_headers_size : Int32 = HTTP::MAX_HEADERS_SIZE) : HTTP::Request | HTTP::Status | Nil #

Returns a `HTTP::Request` instance if successfully parsed, `nil` on EOF or `HTTP::Status` otherwise.

##
Instance Method Detail

def body : IO | Nil #
def body=(body : String) : String #
def body=(body : Bytes) : String #
def body=(body : IO) : IO #
def body=(body : Nil) : Nil #
def content_length #
def content_length=(length : Int) : String #
def cookies : HTTP::Cookies #

Returns a convenience wrapper around querying and setting cookie related headers, see `HTTP::Cookies`.

def form_params : HTTP::Params #

Returns a convenience wrapper to parse form params, see `URI::Params`.

def form_params? : HTTP::Params | Nil #

Returns a convenience wrapper to parse form params, see `URI::Params`. Returns `nil` in case the content type `"application/x-www-form-urlencoded"` is not present or the body is `nil`.

def headers : Headers #
def headers=(headers : Headers) #
def host_with_port : String | Nil #

Returns request host with port from headers.

DEPRECATED Use `headers["Host"]?` instead.

def hostname : String | Nil #

Extracts the hostname from `Host` header.

Returns `nil` if the `Host` header is missing.

If the `Host` header contains a port number, it is stripped off.

def if_match : Array(String) | Nil #
def if_none_match : Array(String) | Nil #
def ignore_body? : Bool #
def keep_alive? : Bool #
def local_address : Socket::Address | Nil #

The network address of the HTTP server.

`HTTP::Server` will try to fill this property, and its value will have a format like "IP:port", but this format is not guaranteed. Middlewares can overwrite this value.

This property is not used by `HTTP::Client`.

def local_address=(local_address : Socket::Address | Nil) #

The network address of the HTTP server.

`HTTP::Server` will try to fill this property, and its value will have a format like "IP:port", but this format is not guaranteed. Middlewares can overwrite this value.

This property is not used by `HTTP::Client`.

def method : String #
def method=(method : String) #
def path : String #

Returns the request's path component.

def path=(path : String) : String #

Sets request's path component.

def query : String | Nil #

Lazily parses and returns the request's query component.

def query=(value : String | Nil) : String | Nil #

Sets request's query component.

def query_params : URI::Params #

Returns a convenience wrapper around querying and setting query params, see `URI::Params`.

def remote_address : Socket::Address | Nil #

The network address that sent the request to an HTTP server.

`HTTP::Server` will try to fill this property, and its value will have a format like "IP:port", but this format is not guaranteed. Middlewares can overwrite this value.

Example:

    class ForwarderHandler
      include HTTP::Handler

      def call(context)
        if ip = context.request.headers["X-Real-IP"]? # When using a reverse proxy that guarantees this field.
          context.request.remote_address = Socket::IPAddress.new(ip, 0)
        end
        call_next(context)
      end
    end

    server = HTTP::Server.new([ForwarderHandler.new, HTTP::LogHandler.new])

This property is not used by `HTTP::Client`.

def remote_address=(remote_address : Socket::Address | Nil) #

The network address that sent the request to an HTTP server.

`HTTP::Server` will try to fill this property, and its value will have a format like "IP:port", but this format is not guaranteed. Middlewares can overwrite this value.

Example:

    class ForwarderHandler
      include HTTP::Handler

      def call(context)
        if ip = context.request.headers["X-Real-IP"]? # When using a reverse proxy that guarantees this field.
          context.request.remote_address = Socket::IPAddress.new(ip, 0)
        end
        call_next(context)
      end
    end

    server = HTTP::Server.new([ForwarderHandler.new, HTTP::LogHandler.new])

This property is not used by `HTTP::Client`.

def resource : String #
def to_io(io : IO) : Nil #
def uri : URI #

Returns the underlying URI object.

Used internally to provide the components of the request uri.

def version : String #
def version=(version : String) #